package patrones.adapter.eje1;

/**
 * El adapter de objeto, se encarga no solo de corregir los nombres de los metodos, sino
 * tambien cosas como conectar y desconectar el motor, cosas que a nuestra
 * implementacien no le importan. Pero lo mas importante es que ahora podemos
 * utilizar esta implemetanacion de Motor en nuestro sistema.
 * 
 */
public class MotorElectricoAdapter extends Motor {
	private MotorElectrico motorElectrico;

	public MotorElectricoAdapter() {
		super();
		this.motorElectrico = new MotorElectrico();
		System.out.println("Creando motor Electrico adapter");
	}

	public void encender() {
		System.out.println("Encendiendo motorElectricoAdapter");
		motorElectrico.conectar();
		motorElectrico.activar();
	}

	public void acelerar() {
		System.out.println("Acelerando motor electrico...");
		motorElectrico.moverMasRapido();
	}

	public void apagar() {
		System.out.println("Apagando motor electrico");
		motorElectrico.detener();
		motorElectrico.desconectar();
	}
}